GONEFISHIN_BUTTON = Y_BUTTON
vec_up = {}
vec3f_set(vec_up,0,1,0)
vec3f_normalize(vec_up)

function mod(x, m)
    m = math.max(1, m);--clamp to minimum 1 because X % 0 or less than 0 is undefined
    return (x % m + m) % m;
end

function lerp(a,b,i,clamped)
    local ret = a+((b-a)*i)

    if(clamped==true)then
        return math.max(a,math.min(b,ret))
    else
        return ret
    end
end

function invlerp(a,b,x,clamped)
    if(clamped==true)then
        x = math.max(a,math.min(b,x))
    end

    return (x-a)/(b-a)
end

function short_angle_to_degrees_angle(short)
    local aShort = -32768
    local bShort = 32767
    local minShort = math.min(aShort,bShort)
    local maxShort = math.max(aShort,bShort)
    local spanShort = maxShort-minShort
    local moduloifiedShort = mod(short-minShort,spanShort)
    local iDegree = invlerp(0,spanShort,moduloifiedShort,false)
    return lerp(0,360,iDegree,false)
end

-- this is so jank and bad
local function degrees_angle_to_xz_vec(d)
    d = math.min(360,math.max(d,0))
    local x =0
    local z  =0

    if(d<180) then
        z = invlerp(90,0,d)

        if(d<90) then
            x = invlerp(0,90,d)
        else
            x = invlerp(180,90,d)
        end
    else
        z = invlerp(270,360,d)

        if(d>=270) then
            x = invlerp(360,270,d)
        else
            x = invlerp(180,270,d)
        end

        x=x*-1
    end

    local ret = {}
    vec3f_set(ret,x,0,z)
    vec3f_mul(ret,-1)-- idk why i have to invert it but oh well
    vec3f_normalize(ret)
    return ret

end

function get_pos_from_projectile_motion(secondsIn, initVelocity, eulerLaunchAngle, gravity, arcDegreesRot, offset)
    if(offset == nil) then
        offset = {}
        vec3f_set(offset,0,0,0)
    end

    radianAngle = eulerLaunchAngle * (math.pi/180)
    xPos = initVelocity * secondsIn * math.cos(radianAngle)
    yPos = initVelocity * secondsIn * math.sin(radianAngle) - 0.5 * gravity * (secondsIn * secondsIn)

    local forAmt = degrees_angle_to_xz_vec(arcDegreesRot)
    vec3f_mul(forAmt,xPos)
    local upAmt = {}
    vec3f_set(upAmt,0,0,0)
    vec3f_copy(upAmt,vec_up)
    vec3f_mul(upAmt,yPos)

    local ret = {}
    vec3f_set(ret,0,0,0)
    vec3f_add(ret,forAmt)
    vec3f_add(ret,upAmt)
    vec3f_add(ret,offset)
    return ret
end