-- name: Gone Fishin'
-- description: TBD

local function detect_begin_action_loop(m)
    local grounded = (m.action & ACT_GROUP_MASK) == ACT_GROUP_MOVING or (m.action & ACT_GROUP_MASK) == ACT_GROUP_STATIONARY
    local inputState  = m.controller.buttonPressed & GONEFISHIN_BUTTON

    if(grounded==true and inputState ~=0 and in_act_loop(m)==false) then
        enter_act_loop(m)
    end 
end

local function detect_end_action_loop(m)
    local in_act_loop_cur = in_act_loop(m)

    if(gPlayerSyncTable[m.playerIndex].in_act_loop_prevVal==true and in_act_loop_cur == false) then
        clean_act_loop(m)
    end

    gPlayerSyncTable[m.playerIndex].in_act_loop_prevVal = in_act_loop_cur
end

hook_event(HOOK_MARIO_UPDATE, detect_begin_action_loop)
hook_event(HOOK_MARIO_UPDATE, detect_end_action_loop)
hook_mario_action(ACT_GONEFISHIN_WINDUP,act_gonefishin_windup)
hook_mario_action(ACT_GONEFISHIN_CAST,act_gonefishin_cast)
hook_mario_action(ACT_GONEFISHIN_BITE,act_gonefishin_bite)
hook_mario_action(ACT_GONEFISHIN_REEL,act_gonefishin_reel)

if(network_is_server()) then
    
    for i =0,(MAX_PLAYERS-1) do
        gPlayerSyncTable[i].windUpTimer_cur = 0
        gPlayerSyncTable[i].castPowerNormalized = 0
        gPlayerSyncTable[i].castDirEulerY = 0
        gPlayerSyncTable[i].castTimer = 0
        gPlayerSyncTable[i].in_act_loop_prevVal = false
    end
end