ACT_GONEFISHIN_WINDUP = ACT_GROUP_STATIONARY | allocate_mario_action(ACT_FLAG_STATIONARY)
ACT_GONEFISHIN_CAST = ACT_GROUP_STATIONARY | allocate_mario_action(ACT_FLAG_STATIONARY)
ACT_GONEFISHIN_BITE = ACT_GROUP_STATIONARY | allocate_mario_action(ACT_FLAG_STATIONARY)
ACT_GONEFISHIN_REEL = ACT_GROUP_STATIONARY | allocate_mario_action(ACT_FLAG_STATIONARY)

local windUpTimer_max = 30

local bobberObjs = {}

function clean_act_loop(m)
    obj_mark_for_deletion(bobberObjs[m.playerIndex])
end

function in_act_loop(m)
    return (m.action == ACT_GONEFISHIN_WINDUP or  m.action == ACT_GONEFISHIN_CAST or  m.action == ACT_GONEFISHIN_BITE or  m.action == ACT_GONEFISHIN_REEL)
end

function act_gonefishin_reel(m)
    
end

function act_gonefishin_bite(m)

end

local function act_gonefishin_cast_init(m,cPN)
    gPlayerSyncTable[m.playerIndex].castPowerNormalized = cPN
    gPlayerSyncTable[m.playerIndex].castTimer = 0
    gPlayerSyncTable[m.playerIndex].castDirEulerY = short_angle_to_degrees_angle(m.marioObj.header.gfx.angle.y)
    bobberObjs[m.playerIndex] = spawn_sync_object(id_bhvGoneFishinBobber,E_MODEL_BOBOMB_BUDDY,m.pos.x,m.pos.y,m.pos.z,function()end)
    set_mario_animation(m,MARIO_ANIM_FIRST_PUNCH)
    set_mario_action(m,ACT_GONEFISHIN_CAST,0)
end

function act_gonefishin_cast(m)
    gPlayerSyncTable[m.playerIndex].castTimer = gPlayerSyncTable[m.playerIndex].castTimer+1

    if(gPlayerSyncTable[m.playerIndex].castTimer>=60)then
        set_mario_action(m,ACT_IDLE,0)
    end
end

function enter_act_loop(m)
    vec3f_set(m.vel,0,0,0)
    gPlayerSyncTable[m.playerIndex].windUpTimer_cur=0
    set_mario_animation(m,MARIO_ANIM_CREDITS_TAKE_OFF_CAP)
    set_mario_action(m,ACT_GONEFISHIN_WINDUP,0)
end

function act_gonefishin_windup(m)
    local advanceCheck = m.controller.buttonPressed & GONEFISHIN_BUTTON

    if(advanceCheck ~=0) then
        act_gonefishin_cast_init(m,invlerp(0,windUpTimer_max,gPlayerSyncTable[m.playerIndex].windUpTimer_cur,true))
    end

    gPlayerSyncTable[m.playerIndex].windUpTimer_cur = gPlayerSyncTable[m.playerIndex].windUpTimer_cur+1

    if(gPlayerSyncTable[m.playerIndex].windUpTimer_cur>=windUpTimer_max)then
        set_mario_action(m,ACT_IDLE,0)
    end
end